/*
 Auto save support code programed by M.Suzuki
 Ver	1.0.0	1997/01/07	Create
*/

#include "config.h"
#include "def.h"

#ifdef	AUTOSAVE
#include <signal.h>

int autoSaveInterval = 10*60;	/* Auto save interval time.(sec)	*/
int autoSavedFlag = FALSE;		/* Auto save after flag	*/
static int saveLock = 0;		/* Auto save local lock counter	*/
static int afterFlag = TRUE;

static VOID AutoSaveHandler ___((int));
static VOID AutoSave ___((void));


void
AutoSaveName(buff,name)
char* buff;
char* name;
{
	strcpy(buff,name);
	if( strlen(name) ){
		char* fn;

		fn = (char*)strrchr(name,'/');
		if( fn == NULL ){
			fn = buff;
		} else {
			fn++;
		}
		strcpy(&buff[strlen(buff)-strlen(fn)],"#");
		strcat(buff,fn);
		strcat(buff,"#");
	}
}

static void
AutoSave ___((void))
{
	BUFFER *bp;
	int currow;
	int curcol;

	alarm(0);		/* disable alarm interrupt	*/
#ifdef	CANNA		/* 97.10.31 by M.Suzuki	*/
	if( cannaKanjiFlag ){	/* kanji mode ?	*/
		afterFlag = TRUE;		/* auto save pending	*/
		return;
	}
#endif	/* CANNA	*/
	currow = ttrow;		/* save cursor position	*/
	curcol = ttcol;
	afterFlag = FALSE;
	bp = bheadp;				/* For all buffers	*/
	while (bp != NULL) {
		if( bp->b_bname[0] != '*' ){		/* Not internal buffer ?	*/
			if( bp->b_flag & BFACHG ){		/* modified ?	*/
				char fname[256];

				AutoSaveName(fname,bp->b_fname);
				writeout(bp,fname);
/*				ttmove(nrow-1,0);
				tteeol();
				ttputs("Auto save");	*/
				bp->b_flag &= ~BFACHG;
			}
		}
		bp = bp->b_bufp;
	}	/* end of while	*/
	ttmove(currow,curcol);
	ttflush();
	alarm(autoSaveInterval);
}

void
AutoSaveLock ___((void))
{
	saveLock++;
}

void
AutoSaveUnlock ___((void))
{
	if( saveLock ){
		saveLock--;
	}
	if( afterFlag == TRUE && saveLock == 0 ){
		AutoSave();
	}
}

void
DeleteAutoSaveFile(name)
char* name;
{
	char fname[256];

	if( strlen(name) && name[0] != '*' ){		/* Not internal buffer ?	*/
		AutoSaveLock();
		AutoSaveName(fname,name);
		unlink(fname);
/*		ewprintf("Unlink ... [%s]",fname);	*/
		AutoSaveUnlock();
	}
}

static VOID
AutoSaveHandler(sig)
int sig;
{
	if( saveLock ){
		afterFlag = TRUE;
	} else {
		AutoSave();
	}
}

void
AutoSaveInit ___((void))
{
	saveLock = 0;
	afterFlag = TRUE;
	AutoSaveLock();
    signal(SIGALRM, AutoSaveHandler);
    alarm(autoSaveInterval);
}

void
AutoSaveTerm ___((void))
{
	BUFFER *bp;

	AutoSaveLock();
	alarm(0);
	bp = bheadp;				/* For all buffers	*/
	while (bp != NULL) {
		if( bp->b_bname[0] != '*' ){		/* Not internal buffer ?	*/
			DeleteAutoSaveFile(bp->b_fname);
		}
		bp = bp->b_bufp;
	}	/* end of while	*/
}

#endif	/* AUTO_SAVE	*/
