/*
 Canna support code programed by M.Suzuki
 Ver	1.0.0	1995/10/25	Create
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include "config.h"
#ifdef	CANNA

#include <canna/jrkanji.h>
#include "def.h"
#include "kbd.h"

#ifndef NO_MACRO
#include	"macro.h"
#endif

#define	TEXT_BUFF	256

char* cannaInitFile = NULL;
char* cannaServer = NULL;
char* cannaModeStr = NULL;
char* cannaOffModeStr = NULL;
int cannaKanjiFlag = 0;			/* Kanji mode flag	*/
static jrKanjiStatus kStatus;
static jrKanjiStatusWithValue kValue;
static char kanjiBuff[TEXT_BUFF];
static char oldDisp[TEXT_BUFF] = "\0";
static int oldPos = 0;
static int oldLen = 0;
static int holdKanjiFlag = 0;	/* Kanji mode keep flag	*/
static int initFlag = 0;
int inlineModeFlag = 0;

#define	PutChar(c)	ttputc(c)
#define	PutStr(s)	ttputs(s)
#define	PutNChar(c,n)	ttputnc(c,n)
#define	PutNStr(s,n)	ttputns(s,n)

static int GetChar ___((void));
static VOID ErrDisp ___((char**));
static int CmpLen ___((char*,char*));
static VOID ReverseDisp ___((char*,int,int,int));
static VOID DiffDisp ___((char*,char*));
static VOID DispKStatus ___((jrKanjiStatus*));

static VOID
CannaModeSet(name)
char* name;
{
	if( cannaModeStr ){
		free(cannaModeStr);
		cannaModeStr = NULL;
	}
	if( name ){
		cannaModeStr = strdup(name);
	}
}

static VOID
CannaInlineEdit(info,len)
jrKanjiStatus* info;
int len;
{
	if ( info->length > 0) {		/* henkan	*/
		int i;

		curwp->w_doto = curwp->w_doto - oldPos;
		ldelete((RSIZE) oldLen, 0);
		linsert( 1, '|');
		for (i=0 ; info->echoStr[i] ; i++) {
			linsert(1,info->echoStr[i]);
		}
		linsert( 1, '|');
		oldLen = info->length + 2 ;
		oldPos = info->revPos + 1;
		curwp->w_doto = curwp->w_doto - oldLen + oldPos;
		kanjiBuff[0] = '\0';
	} else
	if ( info->length == 0 && len == 0) {		/* cancel	*/
		curwp->w_doto = curwp->w_doto - oldPos;
		ldelete((RSIZE) oldLen, 0);
		oldLen = 0;
		oldPos = 0;
		kanjiBuff[0] = '\0';
	}
	if ( info->info & KanjiGLineInfo ) {		/* kouho	*/
		int pos;
		int len;

		eerase();
		pos = oldPos;
		len = oldLen;
		ReverseDisp(info->gline.line,info->gline.length,
					info->gline.revPos,info->gline.revLen);
		oldPos = pos;
		oldLen = len;
	}
}

int
CannaGetChar ___((void))
{
	int len;
	int c;

	if( kanjiBuff[0] == '\0' ){
		if( cannaKanjiFlag == 0 ){	/* none canna mode ?	*/
			return GetChar() & 0x0ff;
		}
#ifdef	READONLY
		if( inlineModeFlag && (curbp->b_flag & BFRONLY) ){
			return GetChar() & 0x0ff;
		}
#endif	/* READONLY */
		while(1){
			jrKanjiStatus kStat;

			if( kStatus.length && !inlineModeFlag ){	/* cursor is mini buffer ?	*/
				ttmove(nrow -1, strlen(oldDisp));
				ttflush();
			}
			c = GetChar();
			if( ISKANJI(c) ){			/* kanji code direct ?	*/
				kanjiBuff[0] = GetChar();
				kanjiBuff[1] = '\0';
				return c & 0xff;
			}
			len = jrKanjiString(0,c,kanjiBuff,TEXT_BUFF,&kStat);
			if( inlineModeFlag ){
				if(kStat.info & KanjiModeInfo){
					CannaModeSet(kStat.mode);
					upmodes(curbp);
				}
				if ( len > 0) {			/* kakutei	*/
					PF funct;
					c = kanjiBuff[0];
					if( (unsigned char)c >= 0x20 || kStat.length == 0 ){
						eerase();
						kanjiBuff[len] = '\0';
						curwp->w_doto = curwp->w_doto - oldPos;
						ldelete((RSIZE) oldLen, 0);
						oldLen = 0;
						oldPos = 0;
						update();
						break;
					}
					kanjiBuff[0] = '\0';
					funct = doscan(curbp->b_modes[curbp->b_nmodes]->p_map,c);
					if( funct == CannaOff || funct == CannaToggle ){	/* kanji mode off. it's very darty (;_;)	*/
						curwp->w_doto = curwp->w_doto - oldPos;
						ldelete((RSIZE) oldLen, 0);
						CannaOff(0,0);
						update();
						return GetChar();
					}
				}
				kStatus = kStat;
				CannaInlineEdit(&kStatus,len);
			} else {
				if( len > 0 ){			/* echo ?	*/
					kanjiBuff[len] = '\0';
					if( (unsigned char)kanjiBuff[0] >= 0x20 && kStat.length >= 0 ){
						kStatus = kStat;
						DispKStatus(&kStatus);
						update();
					}
					break;
				}
				if( kStatus.length >= 0 ){
					kStatus = kStat;
				}
				DispKStatus(&kStatus);
			}
			update();
		}	/* end of while	*/
	}
	if( (c=kanjiBuff[0]) ){
		memmove(&kanjiBuff[0],&kanjiBuff[1],TEXT_BUFF-1);
	}
	return c & 0xff;
}

VOID
CannaSetWidth(len)
int len;
{
	jrKanjiControl(0,KC_SETWIDTH,(char*)len);
}

int
CannaInit(f,n)
int f;
int n;
{
	int ret;
	char** msg;
	char name[256];
	char* initFile;
	char* serverName;

	ewprintf("Canna initialize ...");
	if( initFlag != 0 ){
		initFile = cannaInitFile;
		serverName = cannaServer;
		cannaInitFile = cannaServer = NULL;
		CannaTerm();
		cannaInitFile = initFile;
		cannaServer = serverName;
	}
	if( cannaInitFile == NULL ){
		cannaInitFile = strdup("~/.canna");
	}
	if( cannaInitFile ){
		strcpy(name,cannaInitFile);
		if( cannaInitFile[0] == '~' ){
			strcpy(name,getenv("HOME"));
			strcat(name,&cannaInitFile[1]);
		}
		if( access(name,F_OK) == 0 ){
			jrKanjiControl(0,KC_SETINITFILENAME,(char*)name);
		}
	}
	if( cannaServer == NULL ){
		cannaServer = strdup("unix");
	}
	if( cannaServer ){
		jrKanjiControl(0,KC_SETSERVERNAME,(char*)cannaServer);
	}
	ret = jrKanjiControl(0,KC_INITIALIZE,(char*)&msg);
	ErrDisp(msg);	if( ret )	return FALSE;
	jrKanjiControl(0,KC_SETUNDEFKEYFUNCTION,(char*)kc_through);
	jrKanjiControl(0,KC_SETAPPNAME,version);
	jrKanjiControl(0,KC_QUERYMODE,name);
	CannaModeSet(name);
	cannaOffModeStr = strdup(name);
	initFlag = !0;
	kanjiBuff[0] = oldDisp[0] = '\0';
	oldLen = 0;
	CannaSetWidth(ncol);
	upmodes(NULL);
	update();
	return TRUE;
}

int
CannaTerm ___((void))
{
	int ret;
	char** msg;

	if( initFlag != 0 ){
		CannaModeSet(NULL);
		ret = jrKanjiControl(0,KC_FINALIZE,(char*)&msg);
		ErrDisp(msg);	if( ret )	return FALSE;
	}
	initFlag = 0;
	return TRUE;
}

int
CannaInlineMode(f,n)
int f;
int n;
{
	if( holdKanjiFlag == 0 ){
		if( cannaKanjiFlag ){
			if( inlineModeFlag ){
				jrKanjiControl(0,KC_SETBUNSETSUKUGIRI, FALSE);
			} else {
				jrKanjiControl(0,KC_SETBUNSETSUKUGIRI, (char*)TRUE);
				oldLen = oldPos = 0;
			}
		}
		inlineModeFlag ^= 1;
	}
	return TRUE;
}

int
CannaToggle(f,n)
int f;
int n;
{
	if( cannaKanjiFlag ){
		CannaOff(0,0);
	} else {
		CannaOn(0,0);
	}
	return TRUE;
}

int
CannaOn(f,n)
int f;
int n;
{
	int ret;

	if( initFlag == 0 ){
		if( CannaInit(0,0) == FALSE ){
			return FALSE;
		}
	}
	if( cannaKanjiFlag == 0 ){
		if( inlineModeFlag ){
			jrKanjiControl(0,KC_SETBUNSETSUKUGIRI, (char*)TRUE);
		} else {
			jrKanjiControl(0,KC_SETBUNSETSUKUGIRI, FALSE);
		}
		kValue.ks = &kStatus;
		kValue.buffer = kanjiBuff;
		kValue.bytes_buffer = TEXT_BUFF;
		kValue.val = CANNA_MODE_HenkanMode;
		ret = jrKanjiControl(0,KC_CHANGEMODE,(char*)&kValue);
		cannaKanjiFlag = !0;
		kanjiBuff[0] = oldDisp[0] = '\0';
		oldPos = 0;
		oldLen = 0;
		DispKStatus(&kStatus);
		eerase();
		update();
	}
	return TRUE;
}

int
CannaOff(f,n)
int f;
int n;
{
	int ret;

	if( initFlag ){
		if( cannaKanjiFlag ){
			kValue.ks = &kStatus;
			kValue.buffer = kanjiBuff;
			kValue.bytes_buffer = TEXT_BUFF;
			ret = jrKanjiControl(0,KC_KILL,(char*)&kValue);
			kValue.ks = &kStatus;
			kValue.buffer = kanjiBuff;
			kValue.bytes_buffer = TEXT_BUFF;
			kValue.val = CANNA_MODE_AlphaMode;
			ret = jrKanjiControl(0,KC_CHANGEMODE,(char*)&kValue);
			holdKanjiFlag = cannaKanjiFlag = 0;
			kanjiBuff[0] = oldDisp[0] = '\0';
			oldPos = 0;
			oldLen = 0;
			DispKStatus(&kStatus);
			eerase();
			update();
		}
	}
	return TRUE;
}

VOID
canna_on ___((void))
{
	char buff[TEXT_BUFF];

	if( holdKanjiFlag ){
		holdKanjiFlag = 0;
		cannaKanjiFlag = !0;
		if( !inlineModeFlag ){
			strcpy(buff,oldDisp);
			oldDisp[0] = '\0';
			ReverseDisp(buff,strlen(buff),oldPos,oldLen);
		}
		upmodes(NULL);
		update();
	}
}


VOID
canna_off ___((void))
{
	if ( cannaKanjiFlag ){
		cannaKanjiFlag = 0;
		holdKanjiFlag = !0;
		eerase();
		upmodes(NULL);
		update();
	}
}

static VOID
ReverseDisp(str,max,pos,len)
char* str;
int max;
int pos;
int len;
{
	int i;

	eerase();
	oldPos = pos;
	oldLen = len;
	for(i=0;i<max;i++){
		if( len ){
			if( i == pos ){
				ttcolor(CMODE);
			}
			if( i == pos+len ){
				ttcolor(CTEXT);
			}
		}
		PutChar(str[i]);
		oldDisp[i] = str[i];
	}	/* end of while	*/
	oldDisp[i] = '\0';
	ttcolor(CTEXT);
}

static VOID
DiffDisp(old,new)
char* old;
char* new;
{
	int olen;
	int nlen;
	int len;

	olen = strlen(old);
	nlen = strlen(new);
	len = CmpLen(old,new);
	if( oldLen ){
		if( oldPos < len ){
			len = oldPos;
		}
		oldLen = 0;
	}
	if( len < olen ){
		ttmove(nrow-1, len);	tteeol();
		old[len] = '\0';
	}
	if( len < nlen ){
		ttmove(nrow-1, len);	tteeol();
		PutStr(&new[len]);
		strcpy(&old[len],&new[len]);
	}
}


static VOID
DispKStatus(info)
jrKanjiStatus* info;
{
	if( info->info & KanjiModeInfo ){
		CannaModeSet(info->mode);
		upmodes(curbp);
	}
	if( info->info & KanjiGLineInfo ){
		if( info->gline.length ){
			ReverseDisp(info->gline.line,info->gline.length,
						info->gline.revPos,info->gline.revLen);
			return;
		}
	}
	if( info->revLen ){
		ReverseDisp(info->echoStr,info->length,info->revPos,info->revLen);
		return;
	}
	if( info->length >= 0 ){
		char new[TEXT_BUFF];
		memcpy(new,info->echoStr,info->length);
		new[info->length] = '\0';
		DiffDisp(oldDisp,new);
	}
}

static VOID
ErrDisp(msg)
char** msg;
{
	if( msg ){
		while(*msg){
			ewprintf("canna: %s",*msg);
			msg++;
		}
	}
}


static int
GetChar ___((void))
{
	char buff[1];

	while(read(0, &buff[0], 1) != 1);
	return (buff[0] & 0xFF);
}


static int
CmpLen(str1,str2)
char* str1;
char* str2;
{
	int kflag;
	int len;

	kflag = 0;
	for(len=0;*str1&&*str2;str1++,str2++){
		if( *str1 != *str2 ){
			break;
		}
		if( kflag ){
			kflag = 0;
			len++;
		} else
		if( ISKANJI(*str1) ){
			kflag = 1;
			len--;
		}
		len++;
	}
	return len;
}

int
CannaInitFile(f, n)
int f;
int n;
{
	int s;
	char fname[256];

#ifndef NO_MACRO
	if(macrodef) {
	/* keystrokes arn't collected.	Not hard, but pretty useless */
	/* would not work for function keys in any case */
	    ewprintf("Can't reset canna file in macro");
	    return FALSE;
	}
#ifndef NO_STARTUP
	if(inmacro) {
		s = maclcur->l_used < 256 ? maclcur->l_used : 255;
		memcpy(fname,maclcur->l_text,s);
		fname[s] = '\0';
	    maclcur = maclcur->l_fp;
	} else
#endif
#endif
	{
		if( cannaInitFile != NULL ){
			if( (s=eread("Canna file: (default %s) ",
						 fname,256,EFNEW|EFFILE|EFCR,cannaInitFile))!=TRUE ){
				return s;
			}
		} else {
			if( (s=eread("Canna file: ",fname,256,EFNEW|EFFILE|EFCR))!=TRUE ){
				return s;
			}
		}
	}
	if( cannaInitFile ){
		free(cannaInitFile);
	}
	cannaInitFile = strdup(fname);
	return TRUE;
}

int
CannaServer(f, n)
int f;
int n;
{
	int s;
	char fname[256];

#ifndef NO_MACRO
	if(macrodef) {
	/* keystrokes arn't collected.	Not hard, but pretty useless */
	/* would not work for function keys in any case */
	    ewprintf("Can't reset server in macro");
	    return FALSE;
	}
#ifndef NO_STARTUP
	if(inmacro) {
		s = maclcur->l_used < 256 ? maclcur->l_used : 255;
		memcpy(fname,maclcur->l_text,s);
		fname[s] = '\0';
	    maclcur = maclcur->l_fp;
	} else
#endif
#endif
	{
		if( cannaInitFile != NULL ){
			if( (s=eread("Canna server: (default %s) ",
						 fname,256,EFNEW|EFFILE|EFCR,cannaServer))!=TRUE ){
				return s;
			}
		} else {
			if( (s=eread("Canna server: ",fname,256,EFNEW|EFFILE|EFCR))!=TRUE ){
				return s;
			}
		}
	}
	if( cannaServer ){
		free(cannaServer);
	}
	cannaServer = strdup(fname);
	return TRUE;
}


#endif	/* CANNA */

