
#ifdef	__STDC__
#define	___(x)	x
#else
#define	___(x)	/* none	*/
#endif

/*
 * Externals.
 */

#ifdef	AUTOSAVE	/* 96.12.25 by M.Suzuki	*/
/*
 * Defined by "autosave.c".
 */

extern int autoSaveInterval;	/* Auto save interval time.(sec)	*/
extern int autoSavedFlag;		/* Auto save after flag	*/
extern int auto_save ___((int,int));		/* Auto save interval setup	*/
extern void AutoSaveInit ___((void));
extern void AutoSaveTerm ___((void));
extern void AutoSaveLock ___((void));
extern void AutoSaveUnlock ___((void));
extern void DeleteAutoSaveFile ___((char*));
#endif	/* AUTOSAVE	*/

/*
 * Defined by "basic.c".
 */
extern	int	gotobol ___((int,int));		/* Move to start of line	*/
extern	int	backchar ___((int,int));		/* Move backward by characters	*/
extern	int	gotoeol ___((int,int));		/* Move to end of line		*/
extern	int	forwchar ___((int,int));		/* Move forward by characters	*/
extern	int	gotobob ___((int,int));		/* Move to start of buffer	*/
extern	int	gotoeob ___((int,int));		/* Move to end of buffer	*/
extern	int	forwline ___((int,int));		/* Move forward by lines	*/
extern	int	backline ___((int,int));		/* Move backward by lines	*/
extern	int	forwpage ___((int,int));		/* Move forward by pages	*/
extern	int	backpage ___((int,int));		/* Move backward by pages	*/
extern	int	pagenext ___((int,int));		/* Page forward next window	*/
extern	int	setmark ___((int,int));		/* Set mark			*/
extern	int	swapmark ___((int,int));		/* Swap "." and mark		*/
extern	int	gotoline ___((int,int));		/* Go to a specified line.	*/
#ifdef	GOSMACS
extern	int	forw1page ___((int,int));		/* move forward by lines	*/
extern	int	back1page ___((int,int));		/* move back by lines		*/
#endif
extern	int getgoal ___((LINE*));
extern	VOID isetmark ___((void));

/*
 * Defined by "buffer.c".
 */
extern	int anycb ___((int));
#ifdef	MOVE_BUFFER		/* 95.08.29 by M.Suzuki	*/
extern	int	nextbuffer ___((int,int));		/* Move to the next buffer	*/
extern	int	prevbuffer ___((int,int));		/* Move to the previous buffer	*/
#endif	/* MOVE_BUFFER */
extern	int	listbuffers ___((int,int));		/* Display list of buffers	*/
extern	int	usebuffer ___((int,int));		/* Switch a window to a buffer	*/
extern	int	poptobuffer ___((int,int));		/* Other window to a buffer	*/
extern	int	killbuffer ___((int,int));		/* Make a buffer go away.	*/
extern	int	savebuffers ___((int,int));		/* Save unmodified buffers	*/
extern	int	bufferinsert ___((int,int));		/* Insert buffer into another	*/
extern	int	notmodified ___((int,int));		/* Reset modification flag	*/
#ifdef	READONLY	/* 91.01.05  by S.Yoshida */
extern	int	togglereadonly ___((int,int));	/* Toggle read-only flag	*/
extern	int warnreadonly ___((void));
#else
#define	warnreadonly()	(0)			/* delete trick	*/
#endif	/* READONLY */
extern	int addline ___((BUFFER*,char*));
extern	int bclear ___((BUFFER*));
extern	int showbuffer ___((BUFFER*,WINDOW*,int));
#ifndef NO_HELP
extern	int popbuftop ___((BUFFER*));
#endif
extern	WINDOW	*popbuf ___((BUFFER*));
extern	BUFFER* bfind ___((const char*, const char*));

#ifdef	CANNA		/* 95.10.25 by M.Suzuki	*/
/*
 * Defined by "canna.c".
 */
extern	char* cannaInitFile;		/* init file name	*/
extern	char* cannaServer;			/* server name	*/
extern	char* cannaModeStr;			/* mode name string	*/
extern	char* cannaOffModeStr;
extern	int inlineModeFlag;			/* inline mode flag	*/
extern	int cannaKanjiFlag;			/* Kanji mode flag	*/
extern	int CannaGetChar(void);
extern	int CannaInit ___((int,int));			/* canna-initialize	*/
extern	int CannaTerm ___((void));
extern	int CannaInitFile ___((int,int));		/* canna-init-file	*/
extern	int CannaServer ___((int,int));		/* canna-server	*/
extern	int CannaToggle ___((int,int));		/* canna-toggle-japanese-mode	*/
extern	int CannaOn ___((int,int));			/* canna-henkan-begin	*/
extern	int CannaOff ___((int,int));			/* canna-henkan-end	*/
extern	int CannaInlineMode ___((int,int));		/* canna-toggle-inline-mode	*/
extern	VOID canna_on ___((void));
extern	VOID canna_off ___((void));
extern	VOID CannaSetWidth ___((int));
#endif	/* CANNA */

/*
 * Defined by "cinfo.c".
 */
extern	char	cinfo[];
extern	char	*keyname ___((char*,int));

/*
 * Defined by "cmode.c".
 */
#ifdef	C_MODE	/* 90.07.24  by K.Takano */
#ifdef	TABWIDTH	/* 95.08.29 by M.Suzuki	*/
extern	int default_tab_width ___((int,int));		/* change default tab width		*/
extern	int tab_width ___((int,int));		/* change tab width		*/
#endif	/* TABWIDTH	*/
extern	int	cm_brace ___((int,int));		/* c-mode electric-c-brace	*/
extern	int	cm_semi ___((int,int));		/* c-mode electric-c-semi	*/
extern	int	cm_term ___((int,int));		/* c-mode electric-c-terminator	*/
extern	int	cm_indent ___((int,int));		/* c-mode indent line		*/
extern	int	cm_lfindent ___((int,int));		/* c-mode newline and indent	*/
extern	int	cm_set_indent ___((int,int));	/* set-c-indent-level		*/
extern	int	cm_set_imagin ___((int,int));	/* set-c-brace-imaginary-offset	*/
extern	int	cm_set_brace ___((int,int));		/* set-c-brace-offset		*/
extern	int	cm_set_arg ___((int,int));		/* set-c-argdecl-indent		*/
extern	int	cm_set_label ___((int,int));		/* set-c-label-offset		*/
extern	int	cm_set_cstat ___((int,int));		/* set-c-continued-statement-offset*/
extern	int	cm_set_cbrace ___((int,int));	/* set-c-continued-brace-offset	*/
extern	int	cm_set_newl ___((int,int));		/* set-c-auto-newline		*/
extern	int	cm_set_tab ___((int,int));		/* set-c-tab-always-indent	*/
extern	int	cm_list_var ___((int,int));		/* list-c-mode-variables	*/
#endif	/* C_MODE */

/*
 * Defined by "complt.c"
 */
extern	int complete_list_names ___((char*,int));
extern	int complete_del_list ___((void));
extern	int complete_scroll_up ___((void));
extern	int complete_scroll_down ___((void));

#ifndef NO_DIR
/*
 * Defined by "dir.c"
 */
extern	int	changedir ___((int,int));		/* change current directory	*/
extern	int	showcwdir ___((int,int));		/* show current directory	*/
extern	VOID dirinit ___((void));

#ifndef NO_DIRED
/*
 * defined by "dired.c"
 */
extern	int	dired ___((int,int));		/* dired			*/
extern	int	d_findfile ___((int,int));		/* dired find file		*/
#ifdef	CHGMISC		/* 95.11.12 by M.Suzuki	*/
extern	int d_filereadonly ___((int,int));	/* dired find file read only	*/
#endif	/* CHGMISC	*/
extern	int	d_del ___((int,int));		/* dired mark for deletion	*/
extern	int	d_undel ___((int,int));		/* dired unmark			*/
extern	int	d_undelbak ___((int,int));		/* dired unmark backwards	*/
extern	int	d_expunge ___((int,int));		/* dired expunge		*/
extern	int	d_copy ___((int,int));		/* dired copy			*/
extern	int	d_rename ___((int,int));		/* dired rename			*/
extern	int	d_otherwindow ___((int,int));	/* dired other window		*/
extern	int	d_ffotherwindow ___((int,int));	/* dired find file other window */
#endif
#endif

/*
 * Defined by "display.c".
 */
extern	int	sgarbf;			/* TRUE if screen is garbage.	*/
extern	int	tthue;			/* Current color.		*/
extern	int	ttrow;			/* Physical cursor row.		*/
extern	int	ttcol;			/* Physical cursor column.	*/
extern	int	tttop;			/* Top of scroll region.	*/
extern	int	ttbot;			/* Bottom of scroll region.	*/
extern	VOID vtinit ___((void));
extern	VOID vttidy ___((void));
extern	VOID vtputc ___((int));
extern	int countlines ___((LINE*));
extern	int colrow ___((LINE*,short,int*,int*));
extern	short skipline ___((LINE*,int));
extern	VOID update ___((void));

/*
 * Defined by "echo.c".
 */
extern	VOID ewprintf();
extern	VOID eargset ___((char*));
extern	int ereply();
extern	int eread();
extern	int eyorn ___((char*));
extern	int eyesno ___((char*));
extern	VOID eerase ___((void));

/*
 * Defined by "extend.c".
 */
extern	int	extend ___((int,int));		/* Extended commands.		*/
extern	int	bindtokey ___((int,int));		/* Modify global key bindings.	*/
extern	int	localbind ___((int,int));		/* Modify mode key bindings.	*/
extern	int	define_key ___((int,int));		/* modify any key map		*/
extern	int	unbindtokey ___((int,int));		/* delete global binding	*/
extern	int	localunbind ___((int,int));		/* delete local binding		*/
extern	int	insert ___((int,int));		/* insert string		*/
#ifndef NO_STARTUP
extern	int	evalexpr ___((int,int));		/* Extended commands (again)	*/
extern	int	evalbuffer ___((int,int));		/* Evaluate current buffer	*/
extern	int	evalfile ___((int,int));		/* Evaluate a file		*/
#endif
extern	int load ___((char*));

/*
 * Defined by "file.c".
 */
extern	int	filevisit ___((int,int));		/* Get a file, read write	*/
extern	int	poptofile ___((int,int));		/* Get a file, other window	*/
#ifdef	READONLY	/* 91.01.05  by S.Yoshida */
extern	int	filereadonly ___((int,int));		/* Get a file, read only	*/
#endif	/* READONLY */
extern	int	filewrite ___((int,int));		/* Write a file			*/
extern	int	filesave ___((int,int));		/* Save current file		*/
extern	int	fileinsert ___((int,int));		/* Insert file into buffer	*/
#ifndef NO_BACKUP
extern	int	makebkfile ___((int,int));		/* Control backups on saves	*/
#endif
extern	int readin ___((char*));
extern	int insertfile ___((char*,char*));
extern	int writeout ___((BUFFER*,char*));
extern	int buffsave ___((BUFFER*));
extern	BUFFER *findbuffer ___((char*));
extern	VOID makename ___((char*,char*));
extern	VOID upmodes ___((BUFFER *bp));

/*
 * defined by fileio.c
 */
extern	char	*adjustname ___((char*));
extern	int fbackupfile ___((char*));
extern	int fgetfilemode ___((char*));
extern	int ffputbuf ___((BUFFER*));
extern	int ffropen ___((char*));
extern	int ffwopen ___((char*));
extern	int ffclose ___((void));
extern	int ffgetline ___((char*,int,int*));
extern	int fchkreadonly ___((char*));
extern	int ffisdir ___((char*));
extern	int fffiles ___((char*,char**));
extern	int copy ___((char*,char*));
extern	int d_makename ___((LINE*,char*));
extern	VOID setcrlfmode ___((BUFFER*));
extern	char *file_name_part ___((char*));
extern	BUFFER *dired_ ___((char*));
extern	char * startupfile ___((char*));


/*
 * defined by help.c
 */
#ifndef NO_HELP
extern	int	desckey ___((int,int));		/* describe key			*/
extern	int	wallchart ___((int,int));		/* Make wall chart.		*/
extern	int	help_help ___((int,int));		/* help help			*/
extern	int	apropos_command ___((int,int));	/* apropos			*/
#endif

/*
 * defined by "kanji.c"
 */
#ifdef	KANJI	/* 90.01.29  by S.Yoshida */
extern	VOID kputc ___((int,FILE*,int));
extern	int kgetkey ___((void));
extern	VOID kttputc ___((int));
extern	VOID kdselectcode ___((int));
extern	VOID ksetbufcode ___((BUFFER*));
extern	int kdispbufcode ___((BUFFER*));
extern	VOID kfselectcode ___((FILE*,int));
extern	int iskanji ___((void));
extern	VOID initcategory ___((int));
extern	int incategory ___((void));
extern	int	global_kexpect;		/* kanji-expected-code		*/
extern	int	k_rot_fio ___((int,int));		/* Change global file I/O code.	*/
extern	int	k_set_fio ___((int,int));		/* Set global file I/O code.	*/
extern	int	k_rot_buffio ___((int,int));		/* Change buffer file I/O code.	*/
extern	int	k_set_buffio ___((int,int));		/* Set buffer file I/O code.	*/
extern	int	k_set_expect ___((int,int));		/* Set expected file input code. */
extern	int	k_rot_input ___((int,int));		/* Change keyboard input code.	*/
extern	int	k_set_input ___((int,int));		/* Set keyboard input code.	*/
extern	int	k_rot_display ___((int,int));	/* Change KANJI display code.	*/
extern	int	k_set_display ___((int,int));	/* Set KANJI display code.	*/
extern	int	k_list_code ___((int,int));		/* List each KANJI code values.	*/
extern	int	k_show_code ___((int,int));		/* Show each KANJI code values.	*/
extern	int	k_set_tokfio ___((int,int));		/* Set file KANJI select char.	*/
extern	int	k_set_toafio ___((int,int));		/* Set file ASCII select char.	*/
extern	int	k_set_tokdisplay ___((int,int));	/* Set disp KANJI select char.	*/
extern	int	k_set_toadisplay ___((int,int));	/* Set disp ASCII select char.	*/
#ifdef  HANKANA  /* 92.11.21  by S.Sasaki */
extern	int	k_set_tokanafio ___((int,int));	/* Set file KANA select char.	*/
extern	int	k_set_tokanadisplay ___((int,int));	/* Set disp KANA select char.	*/
extern	int kcodecount ___((char*,int));
#endif  /* HANKANA */
extern	int kcodeconv ___((char*,int,BUFFER*));
extern	VOID ksetfincode  ___((BUFFER*));
extern	int iskword ___((int,int));
extern	VOID kgetkeyflush ___((void));
#endif	/* KANJI */

/*
 * defined by "kbd.c"
 */
#ifndef NO_DPROMPT
extern	char prompt[];
extern	char *promptp;
#endif
#ifdef	KANJI	/* 90.01.29  by S.Yoshida */
extern	int	no_k2nd;		/* We have no KANJI 2nd byte	*/
extern	int	inkfill;		/* Now we are in a fillword().	*/
#endif	/* KANJI */
#ifdef	DO_METAKEY
extern	int	do_meta ___((int,int));		/* interpret meta keys		*/
#endif
#ifdef	BSMAP
extern	int	bsmap ___((int,int));		/* backspace mapping		*/
#endif
extern	int	universal_argument ___((int,int));	/* Ctrl-U			*/
extern	int	digit_argument ___((int,int));	/* M-1, etc.			*/
extern	int	negative_argument ___((int,int));	/* M--				*/
extern	int	selfinsert ___((int,int));		/* Insert character		*/
extern	int	rescan ___((int,int));		/* internal try again function	*/
extern	int getkey ___((int));
extern	int doin ___((void));

/*
 * defined by "keymap.c"
 */
extern	int	nmaps;		/* for use by rebind in extend.c */
#ifdef	NEW_COMPLETE	/* 90.12.10    Sawayanagi Yosirou */
extern	int name_fent ___((char*,int));
#endif	/* NOT NEW_COMPLETE */

/*
 * defined by "kinsoku.c"
 */
#ifdef	KINSOKU	/* 90.01.29  by S.Yoshida */
extern	int	kc_list_char ___((int,int));		/* List BOL/EOL KINSOKU chars.	*/
extern	int	kc_add_bol ___((int,int));		/* Add BOL KINSOKU chars.	*/
extern	int	kc_del_bol ___((int,int));		/* Delete BOL KINSOKU chars.	*/
extern	int	kc_add_eol ___((int,int));		/* Add EOL KINSOKU chars.	*/
extern	int	kc_del_eol ___((int,int));		/* Delete EOL KINSOKU chars.	*/
extern	int isbolkchar ___((int,int));
extern	int iseolkchar ___((int,int));
#endif	/* KINSOKU */

/*
 * defined by "line.c"
 */
extern	int lreplace ___((RSIZE,char*,int));
extern	int lnewline ___((void));
extern	int ldelete ___((RSIZE,int));
extern	int linsert ___((int,int));
extern	int ldelnewline ___((void));
extern	int kinsert ___((int,int));
extern	int kgrow ___((int));
extern	int kremove ___((int));
extern	LINE	*lalloc ___((int));
extern	LINE	*lallocx ___((int));
extern	VOID	kdelete ___((void));
extern	VOID	lchange ___((int));

/*
 * defined by "macro.c"
 */
#ifndef NO_MACRO
extern	int	definemacro ___((int,int));		/* Begin macro			*/
extern	int	finishmacro ___((int,int));		/* End macro			*/
extern	int	executemacro ___((int,int));		/* Execute macro		*/
#endif

/*
 * Defined by "main.c".
 */
extern	int	ctrlg ___((int,int));		/* Abort out of things		*/
extern	int	quit ___((int,int));			/* Quit				*/

/*
 * Defined by "match.c"
 */
extern	int	showmatch ___((int,int));		/* Hack to show matching paren	 */

/* defined by "modes.c" */

extern	int	indentmode ___((int,int));		/* set auto-indent mode		*/
extern	int	fillmode ___((int,int));		/* set word-wrap mode		*/
extern	int	blinkparen ___((int,int));		/* Fake blink-matching-paren var */
#ifdef	NOTAB
extern	int	notabmode ___((int,int));		/* no tab mode			*/
#endif
extern	int	overwrite ___((int,int));		/* overwrite mode		*/
#ifdef	C_MODE	/* 90.07.24  by K.Takano */
extern	int	cmode ___((int,int));		/* set c-mode			*/
#endif	/* C_MODE */
extern	int	set_default_mode ___((int,int));	/* set default modes		*/
#ifdef	CRLFMODE		/* 97.12.10 by M.Suzuki	*/
extern	int crlfmode ___((int,int));	/* CR/LF mode	*/
#endif	/* CRLFMODE	*/
#ifdef	CHGMISC			/* 97.12.12 by M.Suzuki	*/
extern	int set_auto_mode ___((int,int));	/* set-auto-mode	*/
extern	int list_auto_mode ___((int,int));	/* list-auto-mode	*/
extern	int moremode ___((int,int));		/* more-mode	*/
#endif	/* CHGMISC	*/
extern	int setmoremode ___((BUFFER*,int));

/*
 * defined by "paragraph.c" - the paragraph justification code.
 */
extern	int	gotobop ___((int,int));		/* Move to start of paragraph.	*/
extern	int	gotoeop ___((int,int));		/* Move to end of paragraph.	*/
extern	int	fillpara ___((int,int));		/* Justify a paragraph.		*/
extern	int	killpara ___((int,int));		/* Delete a paragraph.		*/
extern	int	setfillcol ___((int,int));		/* Set fill column for justify. */
extern	int	fillword ___((int,int));		/* Insert char with word wrap.	*/
#ifdef	FILLPREFIX	/* 90.12.30  by S.Yoshida */
extern	int	setfillprefix ___((int,int));	/* Set fill prefix strings.	*/
#endif	/* FILLPREFIX */

/*
 * Defined by "random.c".
 */
extern	int	showcpos ___((int,int));		/* Show the cursor position	*/
extern	int	twiddle ___((int,int));		/* Twiddle characters		*/
extern	int	quote ___((int,int));		/* Insert literal		*/
extern	int	openline ___((int,int));		/* Open up a blank line		*/
extern	int	newline ___((int,int));		/* Insert newline		*/
extern	int	deblank ___((int,int));		/* Delete blank lines		*/
extern	int	justone ___((int,int));		/* Delete extra whitespace	*/
extern	int	delwhite ___((int,int));		/* Delete all whitespace	*/
extern	int	indent ___((int,int));		/* Insert newline, then indent	*/
extern	int	forwdel ___((int,int));		/* Forward delete		*/
extern	int	backdel ___((int,int));		/* Backward delete in		*/
extern	int	killline ___((int,int));		/* Kill forward			*/
extern	int	killoneline ___((int,int));		/* Kill current line		*/
extern	int	yank ___((int,int));			/* Yank back from killbuffer.	*/
#ifdef NOTAB
extern	int	space_to_tabstop ___((int,int));
#endif
#ifdef	ADDFUNC	/* 90.02.15  by S.Yoshida */
extern	int	pagelines ___((int,int));		/* Count lines in the page.	*/
extern	int	regionlines ___((int,int));		/* Count lines in the region.	*/
#endif	/* ADDFUNC */
extern	int getcolpos ___((void));

#ifdef	REGEX
/*
 * Defined by "re_search.c"
 */
extern	int	re_forwsearch ___((int,int));	/* Regex search forward		 */
extern	int	re_backsearch ___((int,int));	/* Regex search backwards	 */
extern	int	re_searchagain ___((int,int));	/* Repeat regex search command	 */
extern	int	re_queryrepl ___((int,int));		/* Regex query replace		 */
extern	int	setcasefold ___((int,int));		/* Set case fold in searches	 */
extern	int	delmatchlines ___((int,int));	/* Delete all lines matching	 */
extern	int	delnonmatchlines ___((int,int));	/* Delete all lines not matching */
extern	int	cntmatchlines ___((int,int));	/* Count matching lines		 */
extern	int	cntnonmatchlines ___((int,int));	/* Count nonmatching lines	 */
#endif

/*
 * Defined by "region.c".
 */
#ifdef	CHGMISC		/* 97.11.10 by M.Suzuki	*/
extern	int copywordregion ___((int,int));	/* Copy word to kill buffer.	*/
#endif
extern	int	killregion ___((int,int));		/* Kill region.			*/
extern	int	copyregion ___((int,int));		/* Copy region to kill buffer.	*/
extern	int	lowerregion ___((int,int));		/* Lower case region.		*/
extern	int	upperregion ___((int,int));		/* Upper case region.		*/
#ifdef	PREFIXREGION
extern	int	prefixregion ___((int,int));		/* Prefix all lines in region	*/
extern	int	setprefix ___((int,int));		/* Set line prefix string	*/
#endif

/*
 * Defined by "search.c".
 */
extern	int	forwsearch ___((int,int));		/* Search forward		*/
extern	int	backsearch ___((int,int));		/* Search backwards		*/
extern	int	searchagain ___((int,int));		/* Repeat last search command	*/
extern	int	forwisearch ___((int,int));		/* Incremental search forward	*/
extern	int	backisearch ___((int,int));		/* Incremental search backwards */
extern	int	queryrepl ___((int,int));		/* Query replace		*/

#ifndef NO_SHELL	/* 91.01.10  by K.Maeda */
/*
 * Defined by "shell.c"
 */
#ifdef	CHGMISC		/* 99.03.31 by M.Suzuki	*/
extern	HISTORY* hisTop;
#endif
extern	int	shellcmnd ___((int,int));		/* Get shell command result.	*/
#endif	/* NO_SHELL */

/*
 * Defined by "spawn.c".
 */
extern	int	spawncli ___((int,int));		/* Run CLI in a subjob.		*/
#ifdef	VMS
extern	int	attachtoparent ___((int,int));	/* Attach to parent process	*/
#endif
extern	char *call_process ___((char*,char*));

/*
 * Defined by "tty.c".
 */
extern	int	tceeol;
extern	int	tcinsl;
extern	int	tcdell;
extern	VOID ttinit ___((void));
extern	VOID tttidy ___((void));
extern	VOID ttmove ___((int,int));
extern	VOID tteeol ___((void));
extern	VOID tteeop ___((void));
extern	VOID ttbeep ___((void));
extern	VOID ttinsl ___((int,int,int));
extern	VOID ttdell ___((int,int,int));
extern	VOID ttwindow ___((int,int));
extern	VOID ttnowindow ___((void));
extern	VOID ttcolor ___((int));
extern	VOID ttresize ___((void));

/*
 * Defined by "ttyio.c".
 */
extern	int	nrow;
extern	int	ncol;
#ifdef	J3100	/* 91.01.11  by S.Yoshida */
extern	int	j31_set_cursor ___((int,int));	/* Set J-3100 cursor mode.	*/
#endif	/* J3100 */
#ifdef FEPCTRL	/* 90.11.26  by K.Takano */
extern	int	fepmode_set ___((int,int));		/* Set FEP control mode		*/
extern	int	fepmode_chg ___((int,int));		/* Change FEP control mode	*/
#endif
extern	VOID ttopen ___((void));
extern	int ttraw ___((void));
extern	VOID ttclose ___((void));
extern	int ttcooked ___((void));
extern	VOID ttputc ___((int));
extern	VOID ttputs ___((const char*));
extern	VOID ttputnc ___((int,int));
extern	VOID ttputns ___((const char*,int));
extern	VOID ttflush ___((void));
extern	int ttgetc ___((void));
extern	VOID ttungetc ___((int));
extern	VOID setttysize ___((void));
extern	int typeahead ___((void));
extern	VOID panic ___((char*));
#ifndef NO_DPROMPT
extern	int ttwait ___((void));
#endif

/*
 * Defined by "ttykbd.c".
 */

#ifdef	FKEYS
extern	char	*keystrings[];
#endif

/*
 * Defined by "version.c".
 */
extern char version[];
extern	int	showversion ___((int,int));		/* Show version numbers, etc.	*/
#ifdef	ADDFUNC	/* 90.12.28  by S.Yoshida */
extern	int	showngversion ___((int,int));	/* Show Ng version, etc.	*/
#endif	/* ADDFUNC */
extern	int printversion ___((void));
extern	int printoptions ___((void));

/*
 * Defined by "window.c".
 */
extern	int	reposition ___((int,int));		/* Reposition window		*/
extern	int	refresh ___((int,int));		/* Refresh the screen		*/
extern	int	nextwind ___((int,int));		/* Move to the next window	*/
#ifdef	GOSMACS
extern	int	prevwind ___((int,int));		/* Move to the previous window	*/
#endif
extern	int	onlywind ___((int,int));		/* Make current window only one */
extern	int	splitwind ___((int,int));		/* Split current window		*/
extern	int	delwind ___((int,int));		/* Delete current window	*/
extern	int	enlargewind ___((int,int));		/* Enlarge display window.	*/
extern	int	shrinkwind ___((int,int));		/* Shrink window.		*/
extern	WINDOW	*wpopup ___((void));

/*
 * Defined by "word.c".
 */
extern	int	backword ___((int,int));		/* Backup by words		*/
extern	int	forwword ___((int,int));		/* Advance by words		*/
extern	int	upperword ___((int,int));		/* Upper case word.		*/
extern	int	lowerword ___((int,int));		/* Lower case word.		*/
extern	int	capword ___((int,int));		/* Initial capitalize word.	*/
extern	int	delfword ___((int,int));		/* Delete forward word.		*/
extern	int	delbword ___((int,int));		/* Delete backward word.	*/
extern	int inword ___((void));


#ifdef	AMIGA
#ifdef	DO_ICONIFY
extern	int tticon();
#endif
#ifdef	DO_MENU
extern	int	amigamenu();		/* Menu function		*/
#endif
#ifdef	MOUSE
extern	int	amigamouse();		/* Amiga mouse functions	*/
extern	int	mgotobob();
extern	int	mforwdel();
extern	int	mdelwhite();
extern	int	mdelwind();
extern	int	mgotoeob();
extern	int	menlargewind();
extern	int	mkillline();
extern	int	mkillregion();
extern	int	mdelfword();
extern	int	mreposition();
extern	int	mbackpage();
extern	int	mforwpage();
extern	int	mshrinkwind();
extern	int	msplitwind();
extern	int	myank();
#endif	MOUSE

extern	int	togglewindow();		/* Defined by "ttyio.c"		*/
extern	int	togglezooms();		/*    ""         ""		*/

#ifdef	CHANGE_FONT
extern	int	setfont();		/* Defined by "ttyio.c"		*/
#endif

#ifdef	CHANGE_COLOR
	/* functions to mess with the mode line rendition, window colors*/
extern	int	ttmode();		/* Defined by "tty.c"		*/
extern	int	tttext();		/*  ""				*/
extern	int	textforeground();	/*  ""				*/
extern	int	textbackground();	/*  ""				*/
extern	int	modeforeground();	/*  ""				*/
extern	int	modebackground();	/*  ""				*/
#endif

/*
 * This file contains map segment definitions for adding function keys to
 * keymap declarations.  Currently you can add things to the fundamental
 * mode keymap and the dired mode keymap.  See the declaration of
 * diredmap and fundmap for details.
 */
#include "amiga_maps.c"

#endif	/* AMIGA */


#ifdef	TABWIDTH	/* 95.08.29 by M.Suzuki	*/
#ifndef	CHGMISC		/* 97.12.12 by M.Suzuki	*/
extern	int defaultTabWidth;
#endif
extern	int tabWidth;
#endif	/* TABWIDTH	*/
extern	int	thisflag;
extern	int	lastflag;
extern	int	curgoal;
extern	int	epresf;
extern	int	mode;
extern	WINDOW	*curwp;
extern	BUFFER	*curbp;
extern	WINDOW	*wheadp;
extern	BUFFER	*bheadp;
extern	char	pat[];

/*
 * Standard I/O.
 */
#include <stdlib.h>
#include <string.h>

