/*
 *		Mainline
 */
#include	"config.h"	/* 90.12.20  by S.Yoshida */
#include	"def.h"
#ifndef NO_MACRO
#include	"macro.h"
#endif

int	thisflag;			/* Flags, this command		*/
int	lastflag;			/* Flags, last command		*/
int	curgoal;			/* Goal column			*/
BUFFER	*curbp;				/* Current buffer		*/
WINDOW	*curwp;				/* Current window		*/
BUFFER	*bheadp;			/* BUFFER listhead		*/
WINDOW	*wheadp = (WINDOW *)NULL;	/* WINDOW listhead		*/
char	pat[NPAT];			/* Pattern			*/
static VOID	edinit ___((void));
#ifdef	CHGMISC	/* 97.12.10 by M.Suzuki	*/
char* name_myself;
#endif	/* CHGMISC	*/

int
main(argc, argv)
int  argc;
char **argv;
{
	char	*cp;

#ifdef	CHGMISC	/* 95.10.29 by M.Suzuki	*/
	int i;

	name_myself = file_name_part(argv[0]);
	for(i=1;i<argc;i++){
		char* p;
		p = argv[i];
		if( *p == '-' ){
			p++;
			if( *p == '-' ){
				p++;
			}
			switch(*p++){
			  case 'v':
				printversion();
				exit(GOOD);
			  case 'c':
#ifdef	CANNA	/* 95.10.29 by M.Suzuki	*/
				if( *p == 's' ){
					p++;
					if( *p == '\0' ){
						if( i+1 >= argc ){
							break;
						}
						i++;
					}
				} else
				if( *p == 'i' ){
					p++;
					if( *p == '\0' ){
						if( i+1 >= argc ){
							break;
						}
						i++;
					}
				} else
#endif	/* CANNA	*/
				{
					printversion();
					printoptions();
					exit(GOOD);
				}
			  default:
				break;
			}	/* end of switch	*/
		}
	}	/* end of for	*/
#else
#ifdef	ADDFUNC	/* 90.12.28  by S.Yoshida */
	if (argc > 1 && argv[1][0] == '-') {
		switch (argv[1][1]) {
		    case 'v':
			printversion();
			exit(GOOD);
		    case 'c':
			printversion();
			printoptions();
			exit(GOOD);
		    default:
			break;
		}
	}
#endif
#endif	/* CHGMISC	*/

#ifdef SYSINIT
	SYSINIT;				/* system dependent.	*/
#endif
	vtinit();				/* Virtual terminal.	*/
#ifndef NO_DIR
	dirinit();				/* Get current directory */
#endif
	edinit();				/* Buffers, windows.	*/
	ttykeymapinit();			/* Symbols, bindings.	*/
	/* doing update() before reading files causes the error messages from
	 * the file I/O show up on the screen.	(and also an extra display
	 * of the mode line if there are files specified on the command line.)
	 */
	update();
#ifndef NO_STARTUP				/* User startup file.	*/
	if ((cp = startupfile((char *)NULL)) != NULL)
		(VOID) load(cp);
#endif
	while (--argc > 0) {
#ifdef	CANNA	/* 95.10.29 by M.Suzuki	*/
		char* p;

		p = *++argv;
		if( p[0] == '-' && p[1] == 'c' ){
			p += 2;
			if( *p == 's' ){
				p++;
				if( cannaServer ){
					free(cannaServer);
				}
				if( *p == '\0' ){
					if( --argc <= 0 ){
						break;
					}
					p = *++argv;
				}
				cannaServer = (char*)strdup(p);
				continue;
			} else
			if( *p == 'i'){
				p++;
				if( cannaInitFile ){
					free(cannaInitFile);
				}
				if( *p == '\0' ){
					if( --argc <= 0 ){
						break;
					}
					p = *++argv;
				}
				cannaInitFile = (char*)strdup(p);
				continue;
			}
		}
		cp = adjustname(*argv);
#else
#ifdef  MSDOS
		char argve[NFILEN];
		strncpy(argve, *++argv, NFILEN);
		argve[NFILEN-1] = 0;
		bufstoe(argve, strlen(argve) + 1);
		cp = adjustname(argve);
#else
		cp = adjustname(*++argv);
#endif
#endif	/* CANNA */
#ifndef NO_DIRED	/* 91.01.16  by S.Yoshida */
		if (ffisdir(cp)) {
			eargset(cp);
			(VOID) dired(0, 1);
			continue;
		}
#endif	/* NO_DIRED */
		curbp = findbuffer(cp);
		(VOID) showbuffer(curbp, curwp, 0);
		(VOID) readin(cp);
#ifdef	READONLY	/* 91.01.16  by S.Yoshida */
		if (fchkreadonly(curbp->b_fname)) {
			/* If no write permission, */
			setmoremode(curbp,1);
			ewprintf("File is write protected");
		}
#endif	/* READONLY */
	}
	thisflag = 0;				/* Fake last flags.	*/
	for(;;) {
#ifndef NO_DPROMPT
	    *(promptp = prompt) = '\0';
	    if(epresf == KPROMPT) eerase();
#endif
	    update();
	    lastflag = thisflag;
	    thisflag = 0;
	    switch(doin()) {
		case TRUE: break;
		case ABORT:
		    ewprintf("Quit");		/* and fall through	*/
		case FALSE:
		default:
		    ttbeep();
#ifdef  KANJI
		    kgetkeyflush();
#endif
#ifndef NO_MACRO
		    macrodef = FALSE;
#endif
	    }
	}
	return 0;
}

/*
 * Initialize default buffer and window.
 */
static VOID
edinit ___((void))
{
	register BUFFER *bp;
	register WINDOW *wp;

	bheadp = NULL;
	bp = bfind("*scratch*", "");		/* Text buffer.		*/
	wp = (WINDOW *)malloc(sizeof(WINDOW));	/* Initial window.	*/
	if (bp==NULL || wp==NULL) panic("edinit");
	curbp  = bp;				/* Current ones.	*/
	wheadp = wp;
	curwp  = wp;
	wp->w_wndp  = NULL;			/* Initialize window.	*/
	wp->w_bufp  = bp;
	bp->b_nwnd  = 1;			/* Displayed.		*/
	wp->w_linep = wp->w_dotp = bp->b_linep;
	wp->w_lines = 0;
	wp->w_doto  = 0;
	wp->w_markp = NULL;
	wp->w_marko = 0;
	wp->w_toprow = 0;
	wp->w_ntrows = nrow-2;			/* 2 = mode, echo.	*/
	wp->w_force = 0;
	wp->w_flag  = WFMODE|WFHARD;		/* Full.		*/
}

/*
 * Quit command. If an argument, always
 * quit. Otherwise confirm if a buffer has been
 * changed and not written out. Normally bound
 * to "C-X C-C".
 */
/*ARGSUSED*/
int
quit(f, n)
int f;
int n;
{
	register int	s;

	if ((s = anycb(FALSE)) == ABORT) return ABORT;
	if (s == FALSE
	|| eyesno("Some modified buffers exist, really exit") == TRUE) {
		vttidy();
#ifdef	SYSCLEANUP
	SYSCLEANUP;
#endif
		exit(GOOD);
	}
	return TRUE;
}

/*
 * User abort. Should be called by any input routine that sees a C-g
 * to abort whatever C-g is aborting these days. Currently does
 * nothing.
 */
/*ARGSUSED*/
int
ctrlg(f, n)
int f;
int n;
{
	return ABORT;
}
