/*
 *		Shell commands.
 * The file contains the command
 * processor, shell-command
 *	written by Kaoru Maeda.
 */

#include "config.h"	/* 91.01.10  by S.Yoshida */
#include "def.h"

#ifndef NO_SHELL
#ifdef	CHGMISC		/* 99.03.31 by M.Suzuki	*/
HISTORY* hisTop = NULL;

static VOID
AddHistory(str)
char* str;
{
	HISTORY* his;
	HISTORY* old;
	int len;

	old = NULL;
	for(his=hisTop;his;his=his->next){
		if( strcasecmp(his->str,str) == 0 ){
			if( old ){
				old->next = his->next;
				his->next = hisTop;
				hisTop = his;
			}
			return;
		}
		old = his;
	}   /* end of for   */
	len = strlen(str) + 1;
	if( (his=(HISTORY*)malloc(sizeof(HISTORY)+len)) == NULL ){
		ewprintf("Can't get %d bytes",sizeof(HISTORY)+len);
		return;
	}
	memcpy(his->str,str,len);
	his->next = hisTop;
	hisTop = his;
#if 0
	do{
		if( *str == ' ' ){
			*str = '\t';
		}
		str++;
	}while(len--);
#endif
}
#endif

/*ARGSUSED*/
int
shellcmnd(f, n)
int f;
int n;
{
	char	buf[CMDLINELENGTH];
	char	*result;
	int	s;
	BUFFER	*bp, *obp;
	WINDOW	*wp, *owp;

#ifdef	CHGMISC		/* 99.03.31 by M.Suzuki	*/
	if( hisTop ){
		s = eread("Shell command(%s): ", buf,CMDLINELENGTH, EFNEW|EFHIS,hisTop->str);
	} else {
		s = eread("Shell command: ", buf,CMDLINELENGTH, EFNEW|EFHIS);
	}
	if (s == ABORT) return s;
	if (s == FALSE){
		if(hisTop==NULL){
			return FALSE;
		}
		strcpy(buf,hisTop->str);
	}
#else
	s = ereply("Shell command: ", buf, sizeof buf);
	if (s != TRUE)
		return s;
#endif
	if ((f & FFARG) == 0) {
		if ((bp = bfind("*Shell Command Output*", "")) == NULL) return FALSE;
		if ((wp = popbuf(bp)) == NULL) return FALSE;
#ifdef	AUTOSAVE	/* 96.12.24 by M.Suzuki	*/
		bp->b_flag &= ~(BFCHG | BFACHG);		/* Blow away old.	*/
#else
		bp->b_flag &= ~BFCHG;		/* Blow away old.	*/
#endif	/* AUTOSAVE	*/
		if (bclear(bp) != TRUE) return FALSE;
		obp = curbp; owp = curwp;
		curbp = bp; curwp = wp;
	}
	if ((result = call_process(buf, NULL)) == NULL)
		return FALSE;
#ifdef	CHGMISC		/* 99.03.31 by M.Suzuki	*/
	AddHistory(buf);
#endif
	isetmark();
	s = insertfile(result, (char *)NULL);
	if((f & FFARG) == 0) {
		(VOID) gotobob(0, 1);
		bp->b_dotp = wp->w_dotp;
		bp->b_doto = wp->w_doto;
		curbp = obp;
		curwp = owp;
#ifdef	AUTOSAVE	/* 96.12.24 by M.Suzuki	*/
		bp->b_flag &= ~(BFCHG | BFACHG);
#else
		bp->b_flag &= ~BFCHG;
#endif	/* AUTOSAVE	*/
	}
	unlink(result);
	return s;
}
#endif
