/*
 * fepctrl.h 1.2 1990/11/25	Public Domain.
 *
 * General purpose Japanese FEP control routines for MS-DOS.
 * Written by Junn Ohta <ohta@src.ricoh.co.jp>
 */

/*
 * Japanese FEP type (returned by fep_init())
 */
#define	FEP_NONE     0
#define	FEP_PC98A    1	/* FEP controlled via PC-9801 BIOS (type A) */
#define FEP_PC98B    2	/* FEP controlled via PC-9801 BIOS (type B) */
#define	FEP_MSKANJI  3	/* MS-KANJI Application Interface */
#define	FEP_VJE      4	/* VACS Japanese Entry System Alpha/Sigma/Beta */
#define	FEP_ATOK6    5	/* JUSTSYSTEM's Automatic Transfer of Kana-Kanji 6 */
#define	FEP_ATOK7    6	/* JUSTSYSTEM's Automatic Transfer of Kana-Kanji 7 */
#define	FEP_MTTK86   7	/* K3's Matsutake (pinetree mushroom) 86 */
#define	FEP_MTTK2    8	/* K3's Matsutake (pinetree mushroom) Ver.2 */
#define	FEP_KATANA   9	/* Something Good's Katana/ACE */
#define	FEP_FIXER   10	/* Software Society's FIXER3/FIXER4 */
#define	FEP_EGB2    11	/* ERGOSOFT's EGBridge Ver.2 */
#define	FEP_EGB3    12	/* ERGOSOFT's EGBridge Ver.3 */
#define	FEP_WXP     13	/* A.I.Soft's WXP (and WX, WXS ?) */
#define	FEP_MGR2    14	/* REED REX's MGR2 */
#define	FEP_NEC     15	/* NEC's Chikuji/AI Kana-Kanji Henkan */
#define	FEP_DFJ     16	/* Digital Farm's DFJ Ver.1 */
#define	FEP_KAZE    17	/* Enzan-Hoshi-Gumi's Kaze / Arashi */
#define	FEP_OAK     18	/* OASYS Kana-Kanji Henkan (Fujitsu FM-R series) */
#define	FEP_B16     19	/* Renbunsetsu/Jidou Henkan (Hitachi B16 series) */
#define	FEP_WXPJ    20	/* A.I.Soft's WXP (on Toshiba J3100) */

#define	NFEPS       21	/* Number of FEPs defined */

int	fep_init();
void	fep_term();
void	fep_on(), fep_off();
void	fep_force_on(), fep_force_off();
