/*
 * This file contains the string that get written
 * out by the emacs-version command.
 */
/* 90.01.29	Modified for Ng 1.0 by S.Yoshida */

#include	"config.h"	/* 90.12.20  by S.Yoshida */

#ifdef	ADDFUNC	/* 90.12.28  by S.Yoshida */
#include	"def.h"
#else	/* NOT ADDFUNC */
#define TRUE	1	/* include "def.h" when things get more complicated */
#endif	/* ADDFUNC */

#ifdef	CHGMISC	/* 95.08.29 by M.Suzuki	*/
char version[] = "Ng 1.3.1L" VERSION " [Nihongo Mg 2a] (formerly Micro Nemacs)";
#else
#ifdef	KANJI	/* 90.01.29  by S.Yoshida */
#	ifdef	MSDOS	/* 90.02.11  by S.Yoshida */
#		ifdef	J3100	/* 90.03.10  by S.Yoshida */
char version[] = "Ng 1.3.1L J-3100 version. [Nihongo Mg 2a] (formerly Micro Nemacs)";
#		else	/* NOT J3100 */
#			ifdef	PC9801	/* 90.03.10  by S.Yoshida */
char version[] = "Ng 1.3.1L PC-9801 version. [Nihongo Mg 2a] (formerly Micro Nemacs)";
#			else	/* NOT PC9801 */
char version[] = "Ng 1.3.1L MS-DOS version. [Nihongo Mg 2a] (formerly Micro Nemacs)";
#			endif	/* PC9801 */
#		endif	/* J3100 */
#	else	/* NOT MSDOS */
char version[] = "Ng 1.3.1L [Nihongo Mg 2a] (formerly Micro Nemacs)";
#	endif	/* MSDOS */
#else	/* NOT KANJI */
char version[] = "Mg 2a (formerly MicroGnuEmacs)";
#endif	/* KANJI */
#endif	/* CHGMISC	*/

/*
 * Display the version. All this does
 * is copy the version string onto the echo line.
 */
/*ARGSUSED*/
int
showversion(f, n)
int f;
int n;
{
	ewprintf(version);
	return TRUE;
}

#ifdef	ADDFUNC	/* 90.12.28  by S.Yoshida */
static char* configMsg[]={
#ifdef	AUTOSAVE	/* 96.12.25 by M.Suzuki	*/
	"\tAUTOSAVE\t(Enable auto save control)",
#endif	/* AUTOSAVE	*/
#ifndef	NO_BACKUP
	"\tBACKUP\t\t(Enable backup files)",
#endif
#ifdef	CANNA		/* 95.10.26 by M.Suzuki	*/
	"\tCANNA\t\t(Enable \"Canna\" control)",
#endif
#ifdef	CURSOR_POS
	"\tCURSOR_POS\t(Cursor locates on next CHR after POINT)",
#endif
#ifdef	C_MODE
	"\tC_MODE\t\t(Enable \"c-mode\" functions)",
#endif
#ifdef	NEW_COMPLETE
	"\tCOMPLETE\t(Enable new version completion)",
#endif
#ifdef	CRLFMODE
	"\tCRLFMODE\t(Enable \"crlf-mode\" functions)",
#endif
#ifndef	NO_DIR
	"\tDIR\t\t(Enable directory change functions)",
#endif
#ifndef	NO_DIRED
	"\tDIRED\t\t(Enable \"dired\" mode functions)",
#endif
#ifndef	NO_DPROMPT
	"\tDPROMPT\t\t(Enable delayed prompt)",
#endif
#ifdef	FEPCTRL
	"\tFEPCTRL\t\t(Enable FEP auto control)",
#endif
#ifndef	NO_FILECOMP
	"\tFILECOMP\t(Enable file name completion)",
#endif
#ifdef	FILLPREFIX
	"\tFILLPREFIX\t(Enable fill prefix function)",
#endif
#ifdef	HANKANA
	"\tHANKANA\t\t(Enable Hankaku KANA handling)",
#endif
#ifndef	NO_HELP
	"\tHELP\t\t(Enable help)",
#endif
#ifdef	KANJI
	"\tKANJI\t\t(Enable KANJI handling)",
#endif
#ifdef	KINSOKU
	"\tKINSOKU\t\t(Enable KINSOKU handling)",
#endif
#ifndef	NO_MACRO
	"\tMACRO\t\t(Enable keyboard macros)",
#endif
#ifdef	DO_METAKEY
	"\tMETAKEY\t\t(Enable META key input)",
#endif
#ifdef	PREFIXREGION
	"\tPREFIXREGION\t(Enable \"prefix-region\")",
#endif
#ifdef	READONLY
	"\tREADONLY\t(Enable read-only buffer mode)",
#endif
#ifdef	REGEX
	"\tREGEX\t\t(Enable regular expression functions)",
#endif
#ifndef	NO_SHELL
	"\tSHELL\t\t(Enable shell-command function)",
#endif
#ifndef	NO_STARTUP
	"\tSTARTUP\t\t(Enable startup files)",
#endif
#ifdef	TABWIDTH
	"\tTABWIDTH\t(Enable TAB resize)",
#endif
	NULL};

/*
 * Display the Ng version, compile time options.
 */
/*ARGSUSED*/
int
showngversion(f, n)
int f;
int n;
{
	register BUFFER	*bp;
	register WINDOW	*wp;
	char	 line[80];
	int i;

	if ((bp = bfind("*Ng Version*", "")) == NULL) return FALSE;
#ifdef	AUTOSAVE	/* 96.12.24 by M.Suzuki	*/
	bp->b_flag &= ~(BFCHG | BFACHG);		/* Blow away old.	*/
#else
	bp->b_flag &= ~BFCHG;		/* Blow away old.	*/
#endif	/* AUTOSAVE	*/
	if (bclear(bp) != TRUE) return FALSE;

	if (addline(bp, "Ng version:") == FALSE) return FALSE;
	sprintf(line, "\t%s", version);
	if (addline(bp, line) == FALSE) return FALSE;
	if (addline(bp, "Compile time options:") == FALSE) return FALSE;
	for(i=0;configMsg[i];i++){	
		strcpy(line, configMsg[i]);
		if (addline(bp, line) == FALSE) return FALSE;
	}	/* end of for */

	if ((wp = popbuf(bp)) == NULL)	return FALSE;
	bp->b_dotp = lforw(bp->b_linep); /* put dot at beginning of buffer */
	bp->b_doto = 0;
	wp->w_dotp = bp->b_dotp;	/* fix up if window already on screen */
	wp->w_doto = bp->b_doto;
	return TRUE;
}

/*
 * Print the Ng version to the stdout.
 */
int
printversion ___((void))
{
	printf("Ng version:\n");
	printf("\t%s\n", version);
	return TRUE;
}

/*
 * Print the Ng compile time options.
 */
int
printoptions ___((void))
{
	int i;

	printf("Compile time options:\n");
	for(i=0;configMsg[i];i++){
		printf("%s\n", configMsg[i]);
	}	/* end of for */

	return TRUE;
}
#endif	/* ADDFUNC */
